package com.om.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.om.entity.dto.UpStatusDto;
import com.om.entity.po.Brand;
import com.om.entity.po.DiagnosisVersionDescribe;
import com.om.entity.po.DiagnosisVersionInfo;
import com.om.entity.vo.DiagnosisVersionVO;
import com.om.entity.vo.DignosisPageVO;
import com.om.mapper.DiagnosisVersionInfoMapper;
import com.om.service.IBrandService;
import com.om.service.IClientService;
import com.om.service.IDiagnosisVersionDescribeService;
import com.om.service.IDiagnosisVersionInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.om.utils.Result;
import io.swagger.v3.oas.annotations.parameters.RequestBody;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author bmmx
 * @since 2024-03-06
 */
@Service
public class DiagnosisVersionInfoServiceImpl extends ServiceImpl<DiagnosisVersionInfoMapper, DiagnosisVersionInfo> implements IDiagnosisVersionInfoService {

    @Resource
    IDiagnosisVersionDescribeService describeService;
    @Resource
    IBrandService brandService;
    @Resource
    IClientService clientService;
    @Override
    public Result add(DiagnosisVersionVO diagnosisVersionVO) {
        DiagnosisVersionInfo info = new DiagnosisVersionInfo();
        //copy了文件地址和名称，品牌名称
        BeanUtil.copyProperties(diagnosisVersionVO,info);
        this.save(info);
        LambdaQueryWrapper<DiagnosisVersionInfo> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(DiagnosisVersionInfo::getFile,diagnosisVersionVO.getFile());
        queryWrapper.eq(DiagnosisVersionInfo::getDiagnosisName,diagnosisVersionVO.getDiagnosisName());
        queryWrapper.eq(DiagnosisVersionInfo::getBrandCode,diagnosisVersionVO.getBrandCode());
        //保存后获取
        DiagnosisVersionInfo versionInfo = getOne(queryWrapper);
        DiagnosisVersionDescribe describe = new DiagnosisVersionDescribe();
        describe.setDiagnosisId(versionInfo.getId());
        describe.setDescription(diagnosisVersionVO.getDescriptionList());
        describe.setLanguage(diagnosisVersionVO.getLanguage());
        describeService.save(describe);

        return Result.ok();
    }

    @Override
    public Result downloadFile(Integer id) {
        return null;
    }

    @Override
    public Result edit(DiagnosisVersionVO diagnosisVersionVO) {
        Integer diaId = diagnosisVersionVO.getId();
        DiagnosisVersionInfo versionInfo = getById(diaId);
        versionInfo.setBrandCode(diagnosisVersionVO.getBrandCode());
        versionInfo.setClientNumber(diagnosisVersionVO.getClientNums());
        this.update(versionInfo,null);

        LambdaQueryWrapper<DiagnosisVersionDescribe> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(DiagnosisVersionDescribe::getDiagnosisId,diaId);
        DiagnosisVersionDescribe describe = describeService.getOne(queryWrapper);
        describe.setDescription(diagnosisVersionVO.getDescriptionList());
        describeService.update(describe,null);

        return Result.ok();
    }

    @Override
    public Result getByUserId(Integer id) {
        DiagnosisVersionInfo versionInfo = this.getById(id);
        if (versionInfo == null){
            return Result.ok();
        }

        return null;
    }

    @Override
    public Result getDesc(DiagnosisVersionVO diagnosisVersionVO) {
        return null;
    }

    @Override
    public Result getPageList(DignosisPageVO dignosisPageVO) {
        return null;
    }

    @Override
    public Result release(Integer id) {
        return null;
    }

    @Override
    public Result repeal(Integer id) {
        return null;
    }

    @Override
    public Result upStatus(UpStatusDto upStatusDto) {
        return null;
    }
}
